require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/labels/check_list_elems', type: :request do
  let(:valid_attributes) { {name: 'Text action 1', task_detail_type: 'Corrective'} }
  let(:invalid_attributes) { {name: nil, task_detail_type: nil} }

  # let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  # let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  context 'From logged user' do
    before :each do
      # user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      # user.save!

      sign_in user
    end

    describe 'GET /index' do
      it 'renders a successful response' do
        Labels::CheckListElem.create! valid_attributes
        get labels_check_list_elems_url
        expect(response).to be_successful
      end
    end

    describe 'GET /show' do
      it 'renders a successful response' do
        labels_check_list_elem = Labels::CheckListElem.create! valid_attributes
        get labels_check_list_elem_url(labels_check_list_elem)
        expect(response).to be_successful
      end
    end

    describe 'GET /new' do
      it 'renders a successful response' do
        get new_labels_check_list_elem_url
        expect(response).to be_successful
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        labels_check_list_elem = Labels::CheckListElem.create! valid_attributes
        get edit_labels_check_list_elem_url(labels_check_list_elem)
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new Labels::CheckListElem' do
          expect {
            post labels_check_list_elems_url, params: { labels_check_list_elem: valid_attributes }
          }.to change(Labels::CheckListElem, :count).by(1)
        end

        it 'redirects to the created labels_check_list_elem' do
          post labels_check_list_elems_url, params: { labels_check_list_elem: valid_attributes }
          expect(response).to redirect_to(labels_check_list_elems_url)
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Labels::CheckListElem' do
          expect {
            post labels_check_list_elems_url, params: { labels_check_list_elem: invalid_attributes }
          }.to change(Labels::CheckListElem, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post labels_check_list_elems_url, params: { labels_check_list_elem: invalid_attributes }
          expect(response).to have_http_status(:unprocessable_entity) # be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {name: 'ze new name'} }

        it 'updates the requested labels_check_list_elem' do
          labels_check_list_elem = Labels::CheckListElem.create! valid_attributes
          patch labels_check_list_elem_url(labels_check_list_elem), params: { labels_check_list_elem: new_attributes }
          labels_check_list_elem.reload
          expect(labels_check_list_elem.name).to eq('ze new name')
        end

        it 'redirects to the labels_check_list_elem' do
          labels_check_list_elem = Labels::CheckListElem.create! valid_attributes
          patch labels_check_list_elem_url(labels_check_list_elem), params: { labels_check_list_elem: new_attributes }
          labels_check_list_elem.reload
          expect(response).to redirect_to(labels_check_list_elems_url)
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          labels_check_list_elem = Labels::CheckListElem.create! valid_attributes
          patch labels_check_list_elem_url(labels_check_list_elem), params: { labels_check_list_elem: invalid_attributes }
          expect(response).to have_http_status(:unprocessable_entity) # be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested labels_check_list_elem' do
        labels_check_list_elem = Labels::CheckListElem.create! valid_attributes
        expect {
          delete labels_check_list_elem_url(labels_check_list_elem)
        }.to change(Labels::CheckListElem, :count).by(-1)
      end

      it 'redirects to the labels_check_list_elems list' do
        labels_check_list_elem = Labels::CheckListElem.create! valid_attributes
        delete labels_check_list_elem_url(labels_check_list_elem)
        expect(response).to redirect_to(labels_check_list_elems_url)
      end
    end
  end
end
